RDKit: RDKit::RDProps Class Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
RDKit::RDProps Class Reference

`#include <RDProps.h>`

Inheritance diagram for RDKit::RDProps:

## Public Member Functions
| RDProps ()
| RDProps (const RDProps &rhs)
RDProps & | operator= (const RDProps &rhs)
| RDProps (RDProps &&o) noexcept=default
RDProps & | operator= (RDProps &&rhs) noexcept=default
void | clear ()
const Dict & | getDict () const
| gets the underlying Dictionary
Dict & | getDict ()
STR_VECT | getPropList (bool includePrivate=true, bool includeComputed=true) const
| returns a list with the names of our `properties`
template<typename T>
void | setProp (const std::string &key, T val, bool computed=false) const
| sets a `property` value
template<typename T>
void | getProp (const std::string &key, T &res) const
| allows retrieval of a particular property value
template<typename T>
T | getProp (const std::string &key) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<typename T>
bool | getPropIfPresent (const std::string &key, T &res) const
bool | hasProp (const std::string &key) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | clearProp (const std::string &key) const
| clears the value of a `property`
void | clearComputedProps () const
| clears all of our `computed` `properties`
void | updateProps (const RDProps &source, bool preserveExisting=false)
| update the properties from another

## Protected Attributes
Dict | d_props

## Detailed Description

Definition at line 14 of file RDProps.h.

## Constructor & Destructor Documentation

## ◆ RDProps() [1/3]

RDKit::RDProps::RDProps | ( |  | ) |
| inline

Definition at line 22 of file RDProps.h.

References d_props.

Referenced by RDKit::Bond::Bond(), RDKit::ChemicalReaction::ChemicalReaction(), RDKit::ChemicalReaction::ChemicalReaction(), RDKit::Conformer::Conformer(), RDKit::MolBundle::MolBundle(), RDKit::MolBundle::MolBundle(), operator=(), operator=(), RDProps(), RDProps(), RDKit::ROMol::ROMol(), RDKit::ROMol::ROMol(), RDKit::ROMol::ROMol(), RDKit::SubstanceGroup::SubstanceGroup(), and updateProps().

## ◆ RDProps() [2/3]

RDKit::RDProps::RDProps | ( | const RDProps & | rhs | ) |
| inline

Definition at line 23 of file RDProps.h.

References d_props, and RDProps().

## ◆ RDProps() [3/3]

RDKit::RDProps::RDProps | ( | RDProps && | o | ) |
| defaultnoexcept

References RDProps().

## Member Function Documentation

## ◆ clear()

void RDKit::RDProps::clear | ( |  | ) |
| inline

Definition at line 34 of file RDProps.h.

References d_props.

## ◆ clearComputedProps()

void RDKit::RDProps::clearComputedProps | ( |  | ) | const
| inline

clears all of our `computed` `properties`

Definition at line 149 of file RDProps.h.

References RDKit::detail::computedPropName, d_props, and getPropIfPresent().

## ◆ clearProp()

void RDKit::RDProps::clearProp | ( | const std::string & | key | ) | const
| inline

clears the value of a `property`

Notes:

- if no `property` with name `key` exists, this will be a no-op.
- if the `property` is marked as `computed`, it will also be removed from our list of `computedProperties` This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 136 of file RDProps.h.

References RDKit::detail::computedPropName, d_props, and getPropIfPresent().

Referenced by RDKit::Atom::setAtomMapNum().

## ◆ getDict() [1/2]

Dict & RDKit::RDProps::getDict | ( |  | ) |
| inline

Definition at line 37 of file RDProps.h.

References d_props.

## ◆ getDict() [2/2]

const Dict & RDKit::RDProps::getDict | ( |  | ) | const
| inline

gets the underlying Dictionary

Definition at line 36 of file RDProps.h.

References d_props.

Referenced by updateProps().

## ◆ getProp() [1/2]

template<typename T>

T RDKit::RDProps::getProp | ( | const std::string & | key | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 113 of file RDProps.h.

References d_props.

## ◆ getProp() [2/2]

template<typename T>

void RDKit::RDProps::getProp | ( | const std::string & | key,
|  | T & | res ) const
| inline

allows retrieval of a particular property value

Parameters

  key | the name under which the `property` should be stored. If a `property` is already stored under this name, it will be replaced.
  res | a reference to the storage location for the value.

Notes:

- if no `property` with name `key` exists, a KeyErrorException will be thrown.
- the `boost::lexical_cast` machinery is used to attempt type conversions. If this fails, a `boost::bad_lexical_cast` exception will be thrown. This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 107 of file RDProps.h.

References d_props.

Referenced by RDKit::FileParserUtils::applyMolListProp().

## ◆ getPropIfPresent()

template<typename T>

bool RDKit::RDProps::getPropIfPresent | ( | const std::string & | key,
|  | T & | res ) const
| inline

returns whether or not we have a `property` with name `key` and assigns the value if we do This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 121 of file RDProps.h.

References d_props.

Referenced by clearComputedProps(), clearProp(), RDKit::Atom::getAtomMapNum(), RDKit::MolEnumerator::utils::getMolLinkNodes(), getPropList(), and setProp().

## ◆ getPropList()

STR_VECT RDKit::RDProps::getPropList | ( | bool | includePrivate = true,
|  | bool | includeComputed = true ) const
| inline

returns a list with the names of our `properties`

Definition at line 45 of file RDProps.h.

References RDKit::detail::computedPropName, d_props, and getPropIfPresent().

Referenced by RDKit::FileParserUtils::applyMolListProps(), RDKit::FileParserUtils::applyMolListPropsToAtoms(), and RDKit::FileParserUtils::processMolPropertyLists().

## ◆ hasProp()

bool RDKit::RDProps::hasProp | ( | const std::string & | key | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 126 of file RDProps.h.

References d_props.

Referenced by RDKit::MolDraw2D_detail::addAtomIndices(), RDKit::MolDraw2D_detail::addBondIndices(), RDKit::queryAtomMissingChiralTag(), and RDKit::Atom::setAtomMapNum().

## ◆ operator=() [1/2]

RDProps & RDKit::RDProps::operator= | ( | const RDProps & | rhs | ) |
| inline

Definition at line 24 of file RDProps.h.

References d_props, and RDProps().

Referenced by RDKit::Bond::operator=(), RDKit::Conformer::operator=(), RDKit::ROMol::operator=(), RDKit::SubstanceGroup::operator=(), and RDKit::ChemicalReaction::ReactionPickler.

## ◆ operator=() [2/2]

RDProps & RDKit::RDProps::operator= | ( | RDProps && | rhs | ) |
| defaultnoexcept

References RDProps().

## ◆ setProp()

template<typename T>

void RDKit::RDProps::setProp | ( | const std::string & | key,
|  | T | val,
|  | bool | computed = false ) const
| inline

sets a `property` value

Parameters

  key | the name under which the `property` should be stored. If a `property` is already stored under this name, it will be replaced.
  val | the value to be stored
  computed | (optional) allows the `property` to be flagged `computed`. This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 77 of file RDProps.h.

References RDKit::detail::computedPropName, d_props, and getPropIfPresent().

Referenced by RDKit::MolDraw2D_detail::addAtomIndices(), RDKit::MolDraw2D_detail::addBondIndices(), RDKit::FileParserUtils::createPropertyList(), and RDKit::Atom::setAtomMapNum().

## ◆ updateProps()

void RDKit::RDProps::updateProps | ( | const RDProps & | source,
|  | bool | preserveExisting = false )
| inline

update the properties from another

Definition at line 167 of file RDProps.h.

References d_props, getDict(), and RDProps().

## Member Data Documentation

## ◆ d_props

Dict RDKit::RDProps::d_props
| mutableprotected

Definition at line 16 of file RDProps.h.

Referenced by clear(), clearComputedProps(), clearProp(), getDict(), getDict(), getProp(), getProp(), getPropIfPresent(), getPropList(), hasProp(), operator=(), RDProps(), RDProps(), setProp(), and updateProps().

The documentation for this class was generated from the following file:

- RDProps.h